//============================================================================//
// This source file is part of work done by Reinder Nijhoff (reinder@infi.nl) //
// For the latest info, see http://developer.infi.nl                          //
//                                                                            //
// You're free to use the code in any way you like, modified, unmodified or   //
// cut'n'pasted into your own work.                                           //
//                                                                            //
// Part of this source is based on work by:                                   //
//    - Humus (http://esprit.campus.luth.se/~humus/)                          //
//    - Paul Baker (http://www.paulsprojects.net)                             //
//============================================================================//

#include "background.hpp"

#include "log.hpp"
#include "data.hpp"
#include "factory.hpp"

//==============================================================================
//  Register to Factory
//==============================================================================
bool fac_skybox = Factory_background.reg< Background_skybox >( "skybox" );

//==============================================================================
//  Background::Background()
//==============================================================================
Background::Background() {
}
    
//==============================================================================
//  Background_skybox::init()
//==============================================================================
void Background_skybox::init(Data_node* data) {     
    Background::init( data );

	std::string s;

    if( Data_value* value = data->get_value( "material" ) ) {        
        m_material = Factory_material.create( value );
    }
}
