//============================================================================//
// This source file is part of work done by Reinder Nijhoff (reinder@infi.nl) //
// For the latest info, see http://developer.infi.nl                          //
//                                                                            //
// You're free to use the code in any way you like, modified, unmodified or   //
// cut'n'pasted into your own work.                                           //
//                                                                            //
// Part of this source is based on work by:                                   //
//    - Humus (http://esprit.campus.luth.se/~humus/)                          //
//    - Paul Baker (http://www.paulsprojects.net)                             //
//============================================================================//

#ifndef _BACKGROUND_
#define _BACKGROUND_ 1

#include "includes.hpp"
#include "material.hpp"
#include "geometry.hpp"
#include "data.hpp"

class Material;

//==============================================================================
//  Background
//==============================================================================
class Background {
public:
    Background();
    virtual ~Background() {}
    
    virtual void init(Data_node* data) {}
    virtual Color get_color( const Vector3f& direction ) {}
public:

};

//==============================================================================
//  Background_skybox
//==============================================================================
class Background_skybox : public Background {
public:
	Background_skybox() : Background() {}      
	~Background_skybox() {}
	
	void init(Data_node* data);
	 
    Material* get_material() { return m_material; } 
    void set_material(Material* material) { m_material = material; }

    Color get_color( const Vector3f& direction ) { 
	    return m_material->get_color( Material::DIFFUSE, direction );
    }
protected:
    Material* m_material;
};

#endif /* _BACKGROUND_ */
