[Vertex shader]

uniform vec3 lightPos;

varying vec2 texCoord;
varying vec3 lightVec;

void main(){
	gl_Position = ftransform();
	texCoord = gl_MultiTexCoord0.xy;

	lightVec = lightPos - gl_Vertex.xyz;
}


[Fragment shader]

uniform sampler2D Base;

uniform float invRadius;
uniform float factor;
uniform vec4 lightColor;

varying vec2 texCoord;
varying vec3 lightVec;
varying vec3 normal;

void main(){
	vec4 base = texture2D(Base,  texCoord);

	float distSqr = dot(lightVec, lightVec);

	vec3 lVec = lightVec * inversesqrt(distSqr);

	float atten = clamp(factor * (1.0 - invRadius * invRadius * distSqr), 0.0, 1.0);

	gl_FragColor = atten * base * lightColor;
}
