//============================================================================//
// This source file is part of work done by Reinder Nijhoff (reinder@infi.nl) //
// For the latest info, see http://developer.infi.nl                          //
//                                                                            //
// You're free to use the code in any way you like, modified, unmodified or   //
// cut'n'pasted into your own work.                                           //
//                                                                            //
// Part of this source is based on work by:                                   //
//    - Humus (http://esprit.campus.luth.se/~humus/)                          //
//    - Paul Baker (http://www.paulsprojects.net)                             //
//============================================================================//

#include <iostream>
#include <sstream>
#include <unistd.h>
#include <sys/stat.h>
#include <stdlib.h>

#ifdef _WIN32
#include <windows.h>
#endif

#include "framework.hpp"

int main(int argc, char* argv[])
{
#if 0
    std::string dir, app( argv[0] );
    int pos = app.rfind( "\\", app.size() );
    dir.assign( app, 0, pos );
    chdir( dir.c_str() );
#endif
	 
    Kernel* kernel = new Kernel();
        
    if( argc > 1 ) {
		if( !kernel->read_from_file( argv[1] ) ) {
			return -1;
		}
	} else if( !kernel->read_from_file("scene.txt") ) {
        return -1;
    }
    
    kernel->start_renderer();
    
    while( kernel->update() ) {
       kernel->render();
    }	
	
	logger.get_log_level() = 10;
    kernel->stop_renderer();
                
	
    delete kernel;
        
    return 0;
}

