//============================================================================//
// This source file is part of work done by Reinder Nijhoff (reinder@infi.nl) //
// For the latest info, see http://developer.infi.nl                          //
//                                                                            //
// You're free to use the code in any way you like, modified, unmodified or   //
// cut'n'pasted into your own work.                                           //
//                                                                            //
// Part of this source is based on work by:                                   //
//    - Humus (http://esprit.campus.luth.se/~humus/)                          //
//    - Paul Baker (http://www.paulsprojects.net)                             //
//============================================================================//

#ifndef  _SCENE_
#define  _SCENE_ 1

#include <vector>
#include <string>

#include "includes.hpp"

class Primitive;
class Camera;
class Background;
class Batch;
class Data_node;

//==============================================================================
//  Scene
//==============================================================================
class Scene {
public:
    Scene();
    ~Scene();
    
    virtual void init(Data_node* data);
    void first_update();
    void free_data();

    virtual void render();
    virtual bool update();

    std::vector<Primitive *> m_primitives;
    std::vector<Batch *> m_batches;
    std::vector<Camera *> m_cameras;
    std::vector<Primitive *> m_lights;
    Background* m_background;
private:
};

#endif /* SCENE */

